Subject: bug#64046: 30.0.50; Quoting in customize choice tags

From: Mauro Aranda <[email-masked]>
Date: Wed, 30 Aug 2023 19:58:26 -0300

Stephen Berman <[email-masked]> writes:

 > On Wed, 30 Aug 2023 19:33:21 -0300 Mauro Aranda 
<[email-masked]> wrote:
 >
 >> Stephen Berman <[email-masked]> writes:
 >>
 >>> On Wed, 30 Aug 2023 12:29:47 -0300 Mauro Aranda 
<[email-masked]>
 >>  wrote:
 >>>
 >>>> Stephen Berman <[email-masked]> writes:
 >>>>
 >>>>> On Mon, 28 Aug 2023 11:33:09 +0200 Ola x Nilsson 
<[email-masked]>
 >>>>  wrote:
 >>>>>
 >>>>>> I agree that quote substition should be done on the car of 
simple item
 >>>>>> definitions.  I have no opinion on susbstitute-command-keys vs
 >>>>>> substitute-quotes.  But I came to think about the TITLE argument,
 >>>>>> shouldn't quote substition be performed on it as well?
 >>>>>
 >>>>> I think you're right about that as well, since the title is simply a
 >>>>> display feature.  AFAIK it wouldn't make a noticeable difference for
 >>>>> existing uses of widget-choose in the Customize UI (in the Value menu
 >>>>> the title is simply "Choice" and in the State menu it's "Operation on
 >>>>> <option name>"), but it might be relevant for third party uses or 
future
 >>>>> uses in Emacs, as well as for ad-hoc uses of simple item definitions.
 >>>>> So applying substition to all uses of TITLE seems appropriate.  The
 >>>>> below patch does this, and also corrects my previous patch by 
excluding
 >>>>> substition from the cdr of simple item definitions.
 >>>>
 >>>> What would be a real-life scenario where we need to use
 >>>> substitute-command-keys on TITLE? I can't think of any.
 >>>
 >>> I can't think of a really convincing example where it's needed, but 
just
 >>> as a possibility for stylistic variation, e.g. for simple item
 >>> definitions one could have a more explicit prompt like this:
 >>>
 >>> (widget-choose "Type `0' or `1'" '(("Use `a'" . "Use `1'") ("Use `b'"
 >>> . "Use `2'")))
 >>>
 >>> which would appear as "Type ‘0’ or ‘1’" with curve-style quotes.  For
 >>> the Customize UI, although the title is currently hard-coded as
 >>> "Choice", one could define a widget with a title like "User's choice",
 >>> which would appear as "User’s choice" with the curve-style quote.
 >>> Unless some undesirable consequence of applying substitute-command-keys
 >>> to TITLE is found, I don't see any harm in allowing such uses.
 >>
 >> I vote for don't adding code until it's really needed, and since there
 >> isn't a real feature request for that, I'd leave it out.
 >
 > Well, I took Ola Nilsson's post which drew attention to the possibility
 > of applying quote substition to TITLE (quoted above), as an implicit
 > feature request, and found it plausible.  But...
 >
 >> Looks like we
 >> disagree on this, and it's not really my call, so let's leave it for a
 >> maintainer to decide whether to add that line of code or not.
 >
 > ... I don't have any problem leaving TITLE alone for now. And I do
 > agree with you that an Emacs maintainer should make the decision (also
 > about whether to retain substitute-command-keys or instead use
 > substitute-quotes).

Let's wait then.  And thank you for taking the time to write the code
for it.